use crate::models::parameters::CommandRequest;
use serde::{Deserialize, Serialize};

#[derive(Debug, Serialize, Deserialize, Clone)]
pub struct FindParams {
    pub token: String,
    pub query: String,
}

impl FindParams {
    pub fn new(query: String) -> Self {
        Self {
            token: Default::default(),
            query,
        }
    }
}

impl CommandRequest for FindParams {
    fn token(&self) -> String {
        self.token.clone()
    }

    fn set_token(&mut self, token: String) {
        self.token = token;
    }
}
